#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;


template <typename Type>
void print(const Type& printMe)
{
cout << printMe << endl;
}

int sizePtr(const string* printMe)
{
   return printMe->size();
}

int square(int n)
{
	return n*n;
}

bool isEven(int n)
{
   return ((n&1) == 0);
}

bool myOrder(int x, int y)
{
	return (x > y);
}

string inc()
{
   static string x("cs493");
   //sort(x.begin(), x.end());
   next_permutation(x.begin(), x.end());
   cout << "x is " << x << endl;
   return x;
}

string* getAddr(string& myString)
{
   return &myString;
}

void printptr(int* ptr)
{
   cout << *ptr << endl;
}


int main()
{
   const int VECTOR_LENGTH = 10;

   // Allocate 10 integers (cause the default constructor to get executed
   // VECTOR_LENGTH times.
   vector<int> myInt(VECTOR_LENGTH);
   vector<int> yourInt(VECTOR_LENGTH);
   
   for(int i=0;i<VECTOR_LENGTH;i++)
   {
      myInt[i] = i;
   }

   // Copy the elements from myInt to yourInt.
   // Set an iterator to indicate the first item in myInt
   //vector<int>::iterator it = myInt.begin();
   //vector<int>::iterator itEnd = myInt.end();

   // This should print 0
   //cout << *it << endl;

   // This might cause a crash.
   // cout << *itEnd << endl;
   // 
   // Parameters are:
   // start iterator
   // end iterator
   // start of copy iterator
   // Copy is going assume that yourInt is big enough to hold the copy.
   copy(myInt.begin(), myInt.end(), yourInt.begin());

   // This may crash because the index is out of range - the exact behavior
   // is undefined.
   //myInt[VECTOR_LENGTH+1] = 0;
   
   // This will throw 
   //myInt.at(VECTOR_LENGTH) = 0;

   // Do something to every item in a container.
   for_each(myInt.begin(), myInt.end(), print<int>);

   // If I had a character vector it would work like this.
   // for_each(myChar.begin(), myChar.end(), print<char>);

   // count_if algorithm lets us count the number of items in a container 
   // that meet a particular bool test.
   int nEvens = count_if(myInt.begin(), myInt.end(), isEven);
   cout << nEvens << " of the numbers in the vector are even" << endl;
   
   replace_if(myInt.begin(), myInt.end(), isEven, 1);
   cout << "after replacement:" << endl;
   for_each(myInt.begin(), myInt.end(), print<int>);
   cout << endl;

   // Sort ascending.
   sort(myInt.begin(), myInt.end(), myOrder);
   cout << "after sort:" << endl;
   for_each(myInt.begin(), myInt.end(), print<int>);
   cout << endl;

   // Remove (overwrite) occurrences of 1
   vector<int> myCopy(myInt);
   vector<int>::iterator afterLast = remove(myCopy.begin(), myCopy.end(), 1);
   cout << "after remove:" << endl;
   for_each(myCopy.begin(), afterLast, print<int>);
   cout << endl;
   
   // Remove duplicates - and erase them
   cout << "after unique" << endl;
   myInt.erase(unique(myInt.begin(), myInt.end()), myInt.end());
   for_each(myCopy.begin(), afterLast, print<int>);

   // Transform
   transform(myInt.begin(), myInt.end(), yourInt.begin(), square);

   cout << "after transform:" << endl;
   for_each(yourInt.begin(), yourInt.end(), print<int>);
   cout << endl;

   vector<int>::iterator found = find(yourInt.begin(), yourInt.end(), 81);

   // Generate a sequence
   const int SEQUENCE_LENGTH = 10;
   vector<string> sequence(SEQUENCE_LENGTH);
   cout << "Sequence:"  << endl;
   generate(sequence.begin(), sequence.end(), inc);
   for_each(sequence.begin(), sequence.end(), print<string>);

   // Generate a sequence of ptrs to the
   vector<string*> ptr;
   
   // Get the address of member in the function.
   transform(sequence.begin(), sequence.end(), 
	     back_inserter(ptr), getAddr);

   vector<int> sizes;
   sizes.reserve(SEQUENCE_LENGTH);
   
   // Find all the string sizes
   transform(ptr.begin(), ptr.end(), 
	     back_inserter(sizes), mem_fun(&string::size));

   cout << "sizes: " << endl;
   for_each(sizes.begin(), sizes.end(), print<int>);
   cin.ignore();

}



